Index: src/org/jboss/ide/eclipse/freemarker/dialogs/ContextValueDialog.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/dialogs/ContextValueDialog.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/dialogs/ContextValueDialog.java	(working copy)
@@ -1,40 +1,24 @@
-/*
- * JBoss by Red Hat
- * Copyright 2006-2009, Red Hat Middleware, LLC, and individual contributors as indicated
- * by the @authors tag. See the copyright.txt in the distribution for a
- * full listing of individual contributors.
- *
- * This is free software; you can redistribute it and/or modify it
- * under the terms of the GNU Lesser General Public License as
- * published by the Free Software Foundation; either version 2.1 of
- * the License, or (at your option) any later version.
- *
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this software; if not, write to the Free
- * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
- * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
- */
 package org.jboss.ide.eclipse.freemarker.dialogs;
 
 
+import org.eclipse.core.resources.IFile;
 import org.eclipse.core.resources.IResource;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
 import org.eclipse.jdt.core.IJavaElement;
 import org.eclipse.jdt.core.IJavaProject;
 import org.eclipse.jdt.core.IType;
 import org.eclipse.jdt.core.JavaCore;
 import org.eclipse.jdt.core.JavaModelException;
+import org.eclipse.jdt.core.search.IJavaSearchScope;
 import org.eclipse.jdt.core.search.SearchEngine;
-import org.eclipse.jdt.internal.corext.util.JavaModelUtil;
 import org.eclipse.jdt.ui.JavaUI;
-import org.eclipse.jface.dialogs.Dialog;
 import org.eclipse.jface.dialogs.MessageDialog;
+import org.eclipse.jface.dialogs.StatusDialog;
 import org.eclipse.jface.window.ApplicationWindow;
 import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.ModifyEvent;
+import org.eclipse.swt.events.ModifyListener;
 import org.eclipse.swt.events.MouseEvent;
 import org.eclipse.swt.events.MouseListener;
 import org.eclipse.swt.graphics.Color;
@@ -43,29 +27,48 @@
 import org.eclipse.swt.widgets.Button;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.Group;
 import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Listener;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.swt.widgets.Text;
+import org.eclipse.ui.dialogs.ContainerSelectionDialog;
 import org.eclipse.ui.dialogs.SelectionDialog;
-import org.jboss.ide.eclipse.freemarker.Messages;
+import org.jboss.ide.eclipse.freemarker.FreemarkerMessages;
+import org.jboss.ide.eclipse.freemarker.Plugin;
 import org.jboss.ide.eclipse.freemarker.configuration.ConfigurationManager;
-import org.jboss.ide.eclipse.freemarker.configuration.ContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IContextValue;
+import org.jboss.ide.eclipse.freemarker.configuration.context.IObjectContext;
 
 /**
  * @author <a href="mailto:joe@binamics.com">Joe Hudson</a>
  */
-public class ContextValueDialog extends Dialog {
+public class ContextValueDialog extends StatusDialog {
 
+	private static final int NO_CONTEXT_SELECTED = -1;
+	
 	private IResource resource;
-	private ContextValue contextValue;
+	private IContextValue contextValue;
 
 	private Text keyText;
+	
+	private Label labelText;
 	private Text valueText;
+	private Button browse;
+	
 	private Text singleValueText;
 	private Label singleLabel;
 	private Button singleBrowse;
 	
-	public ContextValueDialog(Shell parentShell, ContextValue contextValue, IResource resource) {
+    // Manage radio button to select a context type 
+	// (Class, String, XML, DTD) 	
+    private Button classRadioButton;
+    private Button stringRadioButton;
+    private Button xmlRadioButton;
+    private Button dtdRadioButton;
+    
+	public ContextValueDialog(Shell parentShell, IContextValue contextValue, IResource resource) {
 		super(parentShell);
 		this.resource = resource;
 		this.contextValue = contextValue;
@@ -75,7 +78,7 @@
 	 * @see org.eclipse.jface.window.Window#configureShell(org.eclipse.swt.widgets.Shell)
 	 */
 	protected void configureShell(Shell newShell) {
-		newShell.setText(Messages.ContextValueDialog_SHELL_CONTEXT_VALUE_CONFIG);
+		newShell.setText(FreemarkerMessages.getString("ContextValueDialog.title"));
 		super.configureShell(newShell);
 	}
 
@@ -84,72 +87,195 @@
 		Composite composite = new Composite(parent, SWT.NULL);
 		composite.setLayout(new GridLayout(3, false));
 
-		Label label = new Label(composite, SWT.NULL);
-		label.setText(Messages.ContextValueDialog_LABEL_NAME);
+        // Coded added by AZ : create Radio Group 
+        // for manage context type Class, String and XML
+        Label label = new Label(composite, 0);
+        label.setText(FreemarkerMessages.getString("ContextValueDialog.contextType.label"));      
+        final Group group = new Group(composite, SWT.NONE);
+		final GridLayout gridLayout = new GridLayout();
+		gridLayout.numColumns = 4;
+		group.setLayout(gridLayout);
+
+        classRadioButton = new Button(group, SWT.RADIO);
+        classRadioButton.setText("Class");
+        classRadioButton.addListener(SWT.Selection, new Listener() {
+            public void handleEvent(Event event) {
+            	handleRadioButon(true);
+            }
+          });
+        stringRadioButton = new Button(group, SWT.RADIO);
+        stringRadioButton.setText("String");
+        stringRadioButton.addListener(SWT.Selection, new Listener() {
+            public void handleEvent(Event event) {
+            	handleRadioButon(true);
+            }
+          });
+        xmlRadioButton = new Button(group, SWT.RADIO);
+        xmlRadioButton.setText("Xml");
+        xmlRadioButton.addListener(SWT.Selection, new Listener() {
+            public void handleEvent(Event event) {
+            	handleRadioButon(true);
+            }
+          });
+        dtdRadioButton = new Button(group, SWT.RADIO);
+        dtdRadioButton.setText("dtd");
+        dtdRadioButton.addListener(SWT.Selection, new Listener() {
+            public void handleEvent(Event event) {
+            	handleRadioButon(true);
+            }
+          });        
+        GridData gd = new GridData(768);
+        gd.horizontalSpan = 2;
+        gd.widthHint = 200;
+        group.setLayoutData(gd);
+        
+        // Select radio swith context type
+        if(contextValue != null) {     
+        	if (contextValue.getType() == IContextValue.CLASS)
+        		classRadioButton.setSelection(true);
+        	else {
+        		if (contextValue.getType() == IContextValue.STRING)
+            		stringRadioButton.setSelection(true);
+            	else {
+            		if (contextValue.getType() == IContextValue.XML)
+                		xmlRadioButton.setSelection(true);
+            		else {
+            			if (contextValue.getType() == IContextValue.DTD)
+                    		dtdRadioButton.setSelection(true);
+            		}
+            	}
+        	}
+        }
+        else {
+            // By default class is selected
+        	classRadioButton.setSelection(true);
+        }
+        
+		label = new Label(composite, SWT.NULL);
+		label.setText(FreemarkerMessages.getString("ContextValueDialog.key.label"));
 		keyText = new Text(composite, SWT.BORDER);
 		if (null != contextValue) {
-			keyText.setText(contextValue.name);
+			keyText.setText(contextValue.getName());
 			keyText.setEnabled(false);
 		}
-		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
+		gd = new GridData(GridData.FILL_HORIZONTAL);
 		gd.horizontalSpan = 2;
 		gd.widthHint = 200;
 		keyText.setLayoutData(gd);
-
-		label = new Label(composite, SWT.NULL);
-		label.setText(Messages.ContextValueDialog_LABEL_TYPE);
+		keyText.addModifyListener(new ModifyListener() {
+			public void modifyText(ModifyEvent e) {
+				dialogChanged();
+			}
+		});
+		
+		labelText = new Label(composite, SWT.NULL);
 		valueText = new Text(composite, SWT.BORDER);
 		valueText.setEnabled(false);
 		valueText.setBackground(new Color(null, 255, 255, 255));
 		gd = new GridData(GridData.FILL_HORIZONTAL);
 		gd.widthHint = 250;
 		valueText.setLayoutData(gd);
-		if (null != contextValue && null != contextValue.objClass) valueText.setText(contextValue.objClass.getName());
-        Button browse = new Button(composite, 8);
-        browse.setText(Messages.ContextValueDialog_BUTTON_BROWSE);
+        // Manage context value for XML, String or class
+        if(contextValue != null) {     
+    		IObjectContext objClass = contextValue.getFirstObjectContext();
+    		if(objClass != null) {
+    			String objectClassName = objClass.getName();
+    			if (objectClassName != null)
+    				valueText.setText(objectClassName);
+    		}
+
+        }
+		valueText.addModifyListener(new ModifyListener() {
+			public void modifyText(ModifyEvent e) {
+				dialogChanged();
+			}
+		});
+		
+		browse = new Button(composite, 8);
+        browse.setText("Browse");
         browse.addMouseListener(new MouseListener() {
             public void mouseDown(MouseEvent e)
             {
                 try {
-                    IJavaProject javaProject = JavaCore.create(resource.getProject());
-                    if(javaProject != null)
-                    {
-                        org.eclipse.jdt.core.search.IJavaSearchScope searchScope = SearchEngine.createJavaSearchScope(new IJavaElement[]{javaProject});
-                        SelectionDialog sd = JavaUI.createTypeDialog(getShell(), new ApplicationWindow(getShell()), searchScope, 2, false);
-                        sd.open();
-                        Object objects[] = sd.getResult();
-                        if(objects != null && objects.length > 0)
-                        {
-                            IType type = (IType)objects[0];
-                            String fullyQualifiedName = type.getFullyQualifiedName('.');
-                            valueText.setText(type.getFullyQualifiedName());
-                            String[] interfaces = type.getSuperInterfaceNames();
-                            boolean isList = false;
-                            if ("java.lang.Object".equals(fullyQualifiedName)) isList = true; //$NON-NLS-1$
-                            else {
-	                            for (int i=0; i<interfaces.length; i++) {
-	                                if (interfaces[i].equals("java.util.Collection") || interfaces[i].equals("java.util.List") || interfaces[i].equals("java.util.Set")) { //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+                	int contextType = getContextTypeSelected();
+                	if (contextType == IContextValue.CLASS) {
+                		// Context type selected is CLASS, open dialog in order
+                		// to display classes availables.
+	                    IJavaProject javaProject = JavaCore.create(resource.getProject());
+	                    if(javaProject != null)
+	                    {
+	                        IJavaSearchScope searchScope = SearchEngine.createJavaSearchScope(new IJavaElement[] {
+	                            javaProject
+	                        });
+	                        SelectionDialog sd = JavaUI.createTypeDialog(getShell(), new ApplicationWindow(getShell()), searchScope, 2, false);
+	                        sd.open();
+	                        Object objects[] = sd.getResult();
+	                        if(objects != null && objects.length > 0)
+	                        {
+	                            IType type = (IType)objects[0];
+	                            String fullyQualifiedName = type.getFullyQualifiedName();
+	                            valueText.setText(type.getFullyQualifiedName());
+	                            String interfaces[] = type.getSuperInterfaceNames();
+	                            boolean isList = false;
+	                            if("java.lang.Object".equals(fullyQualifiedName))
+	                            {
+	                                isList = true;
+	                            } else
+	                            {
+	                                for(int i = 0; i < interfaces.length; i++)
+	                                {
+	                                    if(!interfaces[i].equals("java.util.Collection") && !interfaces[i].equals("java.util.List") && !interfaces[i].equals("java.util.Set"))
+	                                        continue;
 	                                    isList = true;
 	                                    break;
 	                                }
+	
 	                            }
-                            }
-                            if (isList) {
-                                singleBrowse.setEnabled(true);
-                                singleLabel.setEnabled(true);
-                                singleValueText.setEnabled(true);
-                            }
-                            else {
-                                singleBrowse.setEnabled(false);
-                                singleLabel.setEnabled(false);
-                                singleValueText.setEnabled(false);
-                                singleValueText.setText(""); //$NON-NLS-1$
-                            }
-                        }
-                    }
-                    else {
-                        MessageDialog.openError(getShell(), Messages.ContextValueDialog_JAVA_PROJECT_ERROR, Messages.ContextValueDialog_MUST_BE_JAVA_PROJECT);
-                    }
+	                            if(isList)
+	                            {
+	                                singleBrowse.setEnabled(true);
+	                                singleLabel.setEnabled(true);
+	                                singleValueText.setEnabled(true);
+	                            } else
+	                            {
+	                                singleBrowse.setEnabled(false);
+	                                singleLabel.setEnabled(false);
+	                                singleValueText.setEnabled(false);
+	                                singleValueText.setText("");
+	                            }
+	                        }
+	                    } else
+	                    {
+	                        MessageDialog.openError(getShell(), "Java Project Error", "The project must be a java project.");
+	                    }
+                	}
+                	else {
+                		if (contextType == IContextValue.XML ||
+                			contextType == IContextValue.DTD) {
+                       		// Context type selected is XML, open dialog in order
+                    		// to display XML files availables.
+                			OpenResourceDialog  dialog =
+                				new OpenResourceDialog  (getShell(), resource.getProject());
+                				//dialog.setInitialSelections(selectedResources);
+                			if (dialog.open() == ContainerSelectionDialog.OK)
+                			{
+                				Object[] result = dialog.getResult();
+                				if (result.length == 1)
+                				{
+                					IFile xmlFile = (IFile)(result[0]);
+                					if (xmlFile != null) {
+                						//IFile file = resource.getProject().getFile(xmlFile);
+                						valueText.setText(xmlFile.getProjectRelativePath().toString());
+                						// Load XML file into DOM
+                						
+                						
+                						//MessageDialog.openError(getShell(), "Java Project Error", "XML file is not valid.");
+                						
+                					}
+                				}
+                			}
+                		}
+                	}	                    
                 }
                 catch(JavaModelException _ex) { }
             }
@@ -165,20 +291,27 @@
         });
 
         boolean enabled = false;
-        if (null != contextValue && null != contextValue.singularClass) enabled = true;
+        String singularClassName = null;
+        // Manage context value for XML, String or class
+        if (contextValue != null) {
+        	IObjectContext singularClass = contextValue.getSecondObjectContext();
+        	if(singularClass != null) {
+    			singularClassName = singularClass.getName();
+        	}
+        }
 		singleLabel = new Label(composite, SWT.NULL);
 		singleLabel.setEnabled(enabled);
-		singleLabel.setText(Messages.ContextValueDialog_LABEL_LIST_ENTRY_TYPE);
+		singleLabel.setText("List Entry Type:");
 		singleValueText = new Text(composite, SWT.BORDER);
 		singleValueText.setEnabled(enabled);
 		singleValueText.setBackground(new Color(null, 255, 255, 255));
 		gd = new GridData(GridData.FILL_HORIZONTAL);
 		gd.widthHint = 250;
 		singleValueText.setLayoutData(gd);
-		if (enabled) singleValueText.setText(contextValue.singularClass.getName());
+		if (enabled) singleValueText.setText(singularClassName);
         singleBrowse = new Button(composite, 8);
         singleBrowse.setEnabled(enabled);
-        singleBrowse.setText(Messages.ContextValueDialog_BUTTON_BROWSE);
+        singleBrowse.setText("Browse");
         singleBrowse.addMouseListener(new MouseListener() {
             public void mouseDown(MouseEvent e)
             {
@@ -186,7 +319,7 @@
                     IJavaProject javaProject = JavaCore.create(resource.getProject());
                     if(javaProject != null)
                     {
-                        org.eclipse.jdt.core.search.IJavaSearchScope searchScope = SearchEngine.createJavaSearchScope(new IJavaElement[]{javaProject});
+                        IJavaSearchScope searchScope = SearchEngine.createJavaSearchScope(new IJavaElement[]{javaProject});
                         SelectionDialog sd = JavaUI.createTypeDialog(getShell(), new ApplicationWindow(getShell()), searchScope, 2, false);
                         sd.open();
                         Object objects[] = sd.getResult();
@@ -197,7 +330,7 @@
                         }
                     }
                     else {
-                        MessageDialog.openError(getShell(), Messages.ContextValueDialog_JAVA_PROJECT_ERROR, Messages.ContextValueDialog_MUST_BE_JAVA_PROJECT);
+                        MessageDialog.openError(getShell(), "Java Project Error", "The project must be a java project.");
                     }
                 }
                 catch(JavaModelException _ex) { }
@@ -212,29 +345,154 @@
             }
 
         });
+        // Manage disable/enable for radio button
+        handleRadioButon(false);
+        // dialogChanged();
 		return parent;
 	}
 
 	protected void okPressed() {
 	    try {
 		    String name = keyText.getText().trim();
-		    while (name.startsWith("$")) name = name.substring(1, name.length()); //$NON-NLS-1$
-		    if (name.length() == 0) MessageDialog.openError(getShell(), Messages.ContextValueDialog_ERROR, Messages.ContextValueDialog_MUST_CHOOSE_REFERENCE);
+		    while (name.startsWith("$")) name = name.substring(1, name.length());
 		    String className = valueText.getText().trim();
-		    if (className.length() == 0) MessageDialog.openError(getShell(), Messages.ContextValueDialog_ERROR, Messages.ContextValueDialog_MUST_CHOOSE_CLASS);
-		    String singularClassName = singleValueText.getText().trim();
-		    Class singularClass = null;
-		    if (null != singularClassName && singularClassName.trim().length() > 0) singularClass = ConfigurationManager.getInstance(resource.getProject()).getClass(singularClassName);
-		    if (className.length() == 0) singularClassName = null;
-	        contextValue = new ContextValue(
-	                name,
-	                ConfigurationManager.getInstance(resource.getProject()).getClass(className),
-	                singularClass);
-	        ConfigurationManager.getInstance(resource.getProject()).addContextValue(contextValue, resource);
+            String singularClassName = singleValueText.getText().trim();
+            // Coded added by AZ : 
+            // Manage context value for XML, String or class
+            // Get context type
+            int contextType = getContextTypeSelected();
+            IContextValue contextValue = ConfigurationManager.getInstance(resource.getProject()).
+            		getInstanceOfContextValue(contextType, name, className, singularClassName);
+            if (contextValue != null)
+            	ConfigurationManager.getInstance(resource.getProject()).addContextValue(contextValue, resource);
 	    }
 	    catch (Exception e) {
-	        MessageDialog.openError(getShell(), Messages.ContextValueDialog_ERROR, e.getMessage());
+	        MessageDialog.openError(getShell(), "Error", e.getMessage());
 	    }
 		super.okPressed();
 	}
+	
+	 private void handleRadioButon(boolean initialize) {
+    	// 1. manage Key text 
+    	// It is enable ONLY if there is not exist context value
+    	keyText.setEnabled(contextValue == null);
+    	if (initialize) {
+    		singleValueText.setEnabled(false);
+    		singleBrowse.setEnabled(false);
+    		singleLabel.setEnabled(false);
+    	}
+    	boolean selected = classRadioButton.getSelection();
+        if (selected) {
+        	// Class radio button is selected
+        	valueText.setEnabled(false);
+        	browse.setEnabled(true);
+        	labelText.setText("Class:");
+        }
+        else {
+        	selected = stringRadioButton.getSelection();
+        	if (selected) {
+        		// String radio button is selected
+        		valueText.setEnabled(true);
+        		valueText.setFocus();
+        		browse.setEnabled(false);
+        		singleBrowse.setEnabled(false);
+        		labelText.setText("Value:");
+        	}
+        	else {
+        		selected = xmlRadioButton.getSelection();
+            	if (selected) {
+            		// XML radio button is selected
+            		valueText.setEnabled(false);
+            		browse.setEnabled(true);
+            		singleBrowse.setEnabled(false);
+            		labelText.setText("XML:");
+            	}
+            	else {
+            		selected = dtdRadioButton.getSelection();
+                	if (selected) {
+                		// DTD radio button is selected
+                		valueText.setEnabled(false);
+                		browse.setEnabled(true);
+                		singleBrowse.setEnabled(false);
+                		labelText.setText("DTD:");
+                	}
+            	}
+        	}
+        }
+        if (selected && initialize) {
+        	valueText.setText("");
+        	singleValueText.setText("");
+        }
+        String key = keyText.getText();
+		if (keyText.isEnabled() && 
+			key == null || key.trim().length() < 1) {
+    			keyText.setFocus();
+    	}        
+    }
+	    
+    private int getContextTypeSelected() {
+    	if ( classRadioButton.getSelection())
+    		return IContextValue.CLASS;
+    	if ( stringRadioButton.getSelection())
+    		return IContextValue.STRING;
+    	if ( xmlRadioButton.getSelection())
+    		return IContextValue.XML;
+    	if ( dtdRadioButton.getSelection())
+    		return IContextValue.DTD;
+    	return NO_CONTEXT_SELECTED;
+    }
+    
+    private void dialogChanged() {
+    	// Key validation
+    	String name = keyText.getText().trim();
+	    while (name.startsWith("$")) name = name.substring(1, name.length());
+	    if (name.length() == 0) {
+	    	updateMessageStatus("Choose the reference name!");
+	    	return;
+	    }
+	    
+	    // Value validation
+	    String className = valueText.getText().trim();
+        if(className.length() == 0) {
+        	String errorMessage = "";
+        	int contexType = getContextTypeSelected();
+        	if (contexType == IContextValue.CLASS) {
+        		errorMessage = "Choose the class name by using Browse button!";
+        	}
+        	else {
+        		if (contexType == IContextValue.STRING) {
+            		errorMessage = "Select a value for the string!";
+        		}
+            	else {
+            		if (contexType == IContextValue.XML) {
+                		errorMessage = "Choose a XML file by using Browse button!";
+            		}
+            		else {
+                		if (contexType == IContextValue.DTD) {
+                    		errorMessage = "Choose a DTD file by using Browse button!";
+                		}
+            		}
+            	}
+        	}
+        	updateMessageStatus(errorMessage);
+	    	return;
+        }	    
+    	updateMessageStatus(null);
+    }
+    
+    private void updateMessageStatus(String message) {
+    	IStatus status = null;
+    	if (message != null) {
+    		status = new Status(IStatus.ERROR, Plugin.ID, IStatus.ERROR, message, null);
+    	}
+    	else {
+    		status = new Status(IStatus.INFO, Plugin.ID, IStatus.OK, "Click OK to save your context.", null);
+    	}
+    	super.updateStatus(status);
+	}    
+	
+    public void create() {
+		super.create();
+		dialogChanged();
+	}    
 }
\ No newline at end of file
Index: src/org/jboss/ide/eclipse/freemarker/dialogs/OpenResourceDialog.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/dialogs/OpenResourceDialog.java	(revision 0)
+++ src/org/jboss/ide/eclipse/freemarker/dialogs/OpenResourceDialog.java	(revision 0)
@@ -0,0 +1,28 @@
+package org.jboss.ide.eclipse.freemarker.dialogs;
+
+import org.eclipse.core.resources.IContainer;
+import org.eclipse.core.resources.IResource;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.dialogs.ResourceListSelectionDialog;
+import org.jboss.ide.eclipse.freemarker.FreemarkerMessages;
+
+public class OpenResourceDialog extends ResourceListSelectionDialog {
+
+    /**
+     * Creates a new instance of the class.
+     * 
+     * @param parentShell the parent shell
+     * @param container the container
+     * @param typesMask the types mask
+     */
+    public OpenResourceDialog(Shell parentShell, IContainer container) {
+        super(parentShell, container, IResource.FILE);
+        setTitle(FreemarkerMessages.getString("OpenResourceDialog.title"));
+        PlatformUI.getWorkbench().getHelpSystem()
+                .setHelp(parentShell, FreemarkerMessages.getString("OpenResourceDialog.help")
+                        );
+        setAllowUserToToggleDerived(false);
+        setShowDerived(true);  
+    }
+}
Index: src/org/jboss/ide/eclipse/freemarker/model/ListDirective.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/ListDirective.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/ListDirective.java	(working copy)
@@ -86,8 +86,8 @@
 		String[] contents = splitContents();
 		if (contents.length == 4) {
 			String key = contents[3];
-			CompletionInterpolation completionInterpolation = new CompletionInterpolation("${" + contents[1], 0, getItemSet(), getResource()); //$NON-NLS-1$
-			context.put(key, completionInterpolation.getSingularReturnClass(context));
+			CompletionInterpolation completionInterpolation = new CompletionInterpolation("${" + contents[1], 0, getItemSet(), getResource());
+			context.put(key, completionInterpolation.getSingularReturnObject(context));
 		}
 	}
 
Index: src/org/jboss/ide/eclipse/freemarker/model/AssignmentDirective.java
===================================================================
--- src/org/jboss/ide/eclipse/freemarker/model/AssignmentDirective.java	(revision 33273)
+++ src/org/jboss/ide/eclipse/freemarker/model/AssignmentDirective.java	(working copy)
@@ -84,18 +84,18 @@
 			String value = null;
 			if (values.length >= 2) key = values[1];
 			if (values.length >= 4) value = values[3];
-			Class valueClass = null;
+			Object valueObject = null;
 			if (null != value && value.length() > 0) {
-				if (value.charAt(0) == '\"') valueClass = String.class;
-				else if (Character.isDigit(value.charAt(0))) valueClass = Number.class;
+				if (value.charAt(0) == '\"') valueObject = String.class;
+				else if (Character.isDigit(value.charAt(0))) valueObject = Number.class;
 				else {
 					CompletionInterpolation completionInterpolation =
-						new CompletionInterpolation("${" + value, 2, getItemSet(), getResource()); //$NON-NLS-1$
-					valueClass = completionInterpolation.getReturnClass(context);
+						new CompletionInterpolation("${" + value, 2, getItemSet(), getResource());
+                    valueObject = completionInterpolation.getReturnObject(context);
 				}
 			}
 			if (null != key) {
-				context.put(key, valueClass);
+				context.put(key, valueObject);
 			}
 		}
 		super.addToContext(context);
